export declare const enum GesturePriority {
    Minimun = -10000,
    NavigationOptional = -20,
    Navigation = -10,
    Normal = 0,
    Interactive = 10,
    Input = 20,
}
export declare const enum DisableScroll {
    Never = 0,
    DuringCapture = 1,
    Always = 2,
}
export interface GestureOptions {
    disable?: string[];
    disableScroll?: DisableScroll;
    priority?: number;
}
export declare class GestureController {
    private id;
    private requestedStart;
    private disabledGestures;
    private disabledScroll;
    private appRoot;
    private capturedID;
    create(name: string, opts?: GestureOptions): GestureDelegate;
    start(gestureName: string, id: number, priority: number): boolean;
    capture(gestureName: string, id: number, priority: number): boolean;
    release(id: number): void;
    disableGesture(gestureName: string, id: number): void;
    enableGesture(gestureName: string, id: number): void;
    disableScroll(id: number): void;
    enableScroll(id: number): void;
    canStart(gestureName: string): boolean;
    isCaptured(): boolean;
    isScrollDisabled(): boolean;
    isDisabled(gestureName: string): boolean;
}
export declare class GestureDelegate {
    private name;
    private id;
    private controller;
    private disable;
    private disableScroll;
    priority: number;
    constructor(name: string, id: number, controller: GestureController, opts: GestureOptions);
    canStart(): boolean;
    start(): boolean;
    capture(): boolean;
    release(): void;
    destroy(): void;
}
